from collections import defaultdict, deque

def solve(n, m, k, roads, guards):
    g = defaultdict(list)
    for a, b in roads:
        g[a].append(b)
        g[b].append(a)
    
    def bfs(start):
        d = {i: float('inf') for i in range(1, n + 1)}
        d[start] = 0
        q = deque([start])
        v = {start}
        
        while q:
            c = q.popleft()
            for nb in g[c]:
                if nb not in v:
                    v.add(nb)
                    d[nb] = d[c] + 1
                    q.append(nb)
        return d
    
    p = set()
    for pos, h in guards:
        d = bfs(pos)
        for w in range(1, n + 1):
            if d[w] <= h:
                p.add(w)
    
    return sorted(list(p))

def main():
    n, m, k = map(int, input().split())
    roads = []
    for _ in range(m):
        a, b = map(int, input().split())
        roads.append([a, b])
    
    guards = []
    for _ in range(k):
        pos, h = map(int, input().split())
        guards.append([pos, h])
    
    res = solve(n, m, k, roads, guards)
    print(len(res))
    if res:
        print(*res)
    else:
        print()

if __name__ == "__main__":
    main()
