import java.util.*;

public class FortressSolution {
    static class Solution {
        public Set<Integer> solve(int n, int m, int[][] roads, int[][] guards) {
            ArrayList<Integer>[] adj = new ArrayList[n + 1];
            for (int i = 0; i <= n; i++) {
                adj[i] = new ArrayList<>();
            }
            
            for (int[] road : roads) {
                adj[road[0]].add(road[1]);
                adj[road[1]].add(road[0]);
            }
            
            Set<Integer> protected_nodes = new HashSet<>();
            boolean[] visited = new boolean[n + 1];
            ArrayDeque<int[]> queue = new ArrayDeque<>();
            
            for (int[] guard : guards) {
                int pos = guard[0], range = guard[1];
                Arrays.fill(visited, false);
                queue.clear();
                queue.offer(new int[]{pos, 0});
                visited[pos] = true;
                
                while (!queue.isEmpty()) {
                    int[] current = queue.poll();
                    int node = current[0], dist = current[1];
                    
                    if (dist <= range) {
                        protected_nodes.add(node);
                        for (int next : adj[node]) {
                            if (!visited[next]) {
                                visited[next] = true;
                                queue.offer(new int[]{next, dist + 1});
                            }
                        }
                    }
                }
            }
            
            return protected_nodes;
        }
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int m = scanner.nextInt();
        int k = scanner.nextInt();
        
        int[][] roads = new int[m][2];
        for (int i = 0; i < m; i++) {
            roads[i][0] = scanner.nextInt();
            roads[i][1] = scanner.nextInt();
        }
        
        int[][] guards = new int[k][2];
        for (int i = 0; i < k; i++) {
            guards[i][0] = scanner.nextInt();
            guards[i][1] = scanner.nextInt();
        }
        
        Solution solution = new Solution();
        Set<Integer> result = solution.solve(n, m, roads, guards);
        
        System.out.println(result.size());
        if (!result.isEmpty()) {
            ArrayList<Integer> sorted = new ArrayList<>(result);
            Collections.sort(sorted);
            for (int i = 0; i < sorted.size(); i++) {
                System.out.print(sorted.get(i));
                if (i < sorted.size() - 1) {
                    System.out.print(" ");
                }
            }
            System.out.println();
        } else {
            System.out.println();
        }
        
        scanner.close();
    }
}
