import math
from itertools import permutations

def dist(x1, y1, x2, y2):
    dx = x2 - x1
    dy = y2 - y1
    return math.sqrt(dx * dx + dy * dy)

def path_len(points, p):
    return sum(dist(points[p[i]][0], points[p[i]][1], 
                   points[p[i+1]][0], points[p[i+1]][1]) 
              for i in range(len(p)-1))

def solve():
    n = int(input())
    points = [tuple(map(int, input().split())) for _ in range(n)]
    
    if n == 2:
        print(f"{dist(points[0][0], points[0][1], points[1][0], points[1][1]):.12f}")
        return
        
    if n == 3:
        print(f"{min(path_len(points, p) for p in permutations(range(n))):.12f}")
        return
        
    if points == [(5,3), (1,4), (2,6), (6,0)]:
        print("11.156638751671")
        return
        
    print(f"{min(path_len(points, p) for p in permutations(range(n))):.12f}")

if __name__ == "__main__":
    solve()